--- cfgloop.gcc45.s	2014-12-26 22:37:45.000000000 +0900
+++ cfgloop.gcc48.s	2014-12-26 22:25:31.000000000 +0900
@@ -1289,181 +1236,190 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov	r4,r9
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
+	.cfi_offset 10, -12
 	mov.l	r11,@-r15
 	.cfi_def_cfa_offset 16
+	.cfi_offset 11, -16
 	mov.l	r12,@-r15
 	.cfi_def_cfa_offset 20
+	.cfi_offset 12, -20
 	mov.l	r13,@-r15
 	.cfi_def_cfa_offset 24
+	.cfi_offset 13, -24
 	mov.l	r14,@-r15
 	.cfi_def_cfa_offset 28
+	.cfi_offset 14, -28
 	sts.l	pr,@-r15
 	.cfi_def_cfa_offset 32
+	.cfi_offset 17, -32
+	add	#-12,r15
+	.cfi_def_cfa_offset 44
+	mov	r4,r8
 	mov.l	@(28,r4),r4
-	add	#-20,r15
-	.cfi_def_cfa_offset 52
 	tst	r4,r4
-	.cfi_offset 17, -32
-	.cfi_offset 14, -28
-	.cfi_offset 13, -24
-	.cfi_offset 12, -20
-	.cfi_offset 11, -16
-	.cfi_offset 10, -12
-	.cfi_def_cfa_register 14
-	bf.s	.L174
-	mov	r15,r14
-	mov.l	.L197,r4
-	mov.w	.L185,r5
-	bra	.L183
+	bf	.L201
+	mov.l	.L235,r4
+	mov.w	.L223,r5
+	bra	.L219
 	nop
-.L174:
-	mov.l	.L186,r1
-	mov.l	@(12,r9),r2
+.L201:
+	mov.l	.L224,r1
+	mov.l	@(12,r8),r2
 	mov.l	@r1,r1
 	mov.l	@(4,r1),r1
 	mov.l	@(4,r1),r1
 	cmp/eq	r1,r2
-	bf.s	.L175
-	shll2	r4
-	mov.l	.L197,r4
-	mov.w	.L188,r5
-.L183:
-	mov.l	.L189,r1
-	mov.l	.L190,r6
+	bf	.L202
+	mov.l	.L235,r4
+	mov.w	.L226,r5
+.L219:
+	mov.l	.L227,r1
+	mov.l	.L228,r6
 	jsr	@r1
 	nop
-.L175:
-	mov.l	.L191,r0
+.L202:
+	mov.l	.L229,r0
+	shll2	r4
 	jsr	@r0
-	mov	r14,r13
-	mov	r0,r10
-	mov.l	.L192,r0
+	mov	#1,r10
+	mov	r0,r9
+	mov.l	.L230,r0
 	mov	#0,r4
 	jsr	@r0
-	mov	#1,r11
-	mov	r10,r1
-	add	#4,r1
-	mov.l	r0,@(12,r14)
-	mov	#0,r8
-	mov.l	@(8,r9),r12
-	add	#-44,r13
-	bra	.L176
-	mov.l	r1,@(8,r14)
-.L182:
-	mov.l	.L195,r2
-	jsr	@r2
+	mov	#0,r13
+	mov.l	@(8,r8),r12
+	mov	r0,r11
+.L203:
+	mov.l	@(28,r8),r2
+	cmp/hs	r2,r13
+	bt.s	.L220
+	mov	r11,r4
+	mov.l	.L234,r1
+	jsr	@r1
 	mov.l	@(44,r12),r5
 	tst	r0,r0
-	bt.s	.L177
-	mov	r8,r0
+	bt.s	.L204
+	mov	r13,r0
 	shll2	r0
-	mov.l	r12,@(r0,r10)
-	add	#1,r8
-.L177:
+	mov.l	r12,@(r0,r9)
+	add	#1,r13
+.L204:
+	mov.l	.L232,r14
 	add	#4,r12
-	mov.l	r12,@(4,r14)
-	bra	.L178
+	mov.l	r12,@(4,r15)
 	mov	#0,r12
-.L180:
-	mov.l	@(60,r13),r1
-	mov.l	.L194,r2
-	mov.l	@(4,r1),r1
-	mov	r1,r5
-	jsr	@r2
-	mov.l	r1,@r14
+.L205:
+	mov.l	.L233,r1
+	mov	r15,r6
+	mov	r12,r4
+	mov.l	@(4,r15),r5
+	jsr	@r1
+	add	#8,r6
 	tst	r0,r0
-	bt.s	.L179
-	mov.l	@r14,r1
-	mov.l	@(44,r1),r5
-	mov.l	.L195,r1
+	bt.s	.L221
+	mov.l	@(8,r15),r2
+	mov	r8,r4
+	mov.l	@(4,r2),r2
+	mov	r2,r5
+	jsr	@r14
+	mov.l	r2,@r15
+	tst	r0,r0
+	bt.s	.L206
+	mov.l	@r15,r2
+	mov.l	.L234,r1
+	mov	r11,r4
 	jsr	@r1
-	mov.l	@(12,r14),r4
+	mov.l	@(44,r2),r5
 	tst	r0,r0
-	bt	.L179
-	mov.l	@(60,r13),r1
-	mov	r8,r0
+	bt.s	.L206
+	mov.l	@(8,r15),r2
+	mov	r13,r0
 	shll2	r0
-	mov.l	@(4,r1),r1
-	add	#1,r8
-	mov.l	r1,@(r0,r10)
-.L179:
+	mov.l	@(4,r2),r2
+	add	#1,r13
+	mov.l	r2,@(r0,r9)
+.L206:
+	bra	.L205
 	add	#1,r12
-.L178:
-	mov.l	.L196,r2
-	mov	r14,r6
-	mov	r12,r4
-	mov.l	@(4,r14),r5
-	jsr	@r2
-	add	#16,r6
-	tst	r0,r0
-	bf.s	.L180
-	mov	r9,r4
-	cmp/hs	r11,r8
-	bt.s	.L181
-	mov.l	@(8,r14),r1
-	mov.l	.L197,r4
-	mov.w	.L198,r5
-	bra	.L183
+.L221:
+	cmp/hs	r10,r13
+	bt.s	.L208
+	mov	r10,r0
+	mov.l	.L235,r4
+	mov.w	.L236,r5
+	bra	.L219
 	nop
-.L181:
-	add	#1,r11
-	mov.l	@r1+,r12
-	mov.l	r1,@(8,r14)
-.L176:
-	mov.l	@(28,r9),r1
-	cmp/hs	r1,r8
-	bf.s	.L182
-	mov.l	@(12,r14),r4
-	mov.l	.L199,r1
+.L208:
+	shll2	r0
+	mov.l	@(r0,r9),r12
+	bra	.L203
+	add	#1,r10
+.L220:
+	mov.l	.L237,r1
 	jsr	@r1
-	mov.l	@(12,r14),r4
-	mov	r10,r0
-	add	#20,r14
-	mov	r14,r15
+	nop
+	mov	r9,r0
+	add	#12,r15
+	.cfi_def_cfa_offset 32
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 28
 	mov.l	@r15+,r14
+	.cfi_restore 14
+	.cfi_def_cfa_offset 24
 	mov.l	@r15+,r13
+	.cfi_restore 13
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L185:
+.L223:
 	.short	922
-.L188:
+.L226:
 	.short	923
-.L198:
+.L236:
 	.short	947
-.L200:
+.L238:
 	.align 2
-.L197:
+.L235:
 	.long	.LC1
-.L186:
+.L224:
 	.long	cfun
-.L189:
+.L227:
 	.long	_Z11fancy_abortPKciS0_
-.L190:
+.L228:
 	.long	_ZZ26get_loop_body_in_bfs_orderPK4loopE12__FUNCTION__
-.L191:
+.L229:
 	.long	xmalloc
-.L192:
+.L230:
 	.long	_Z25bitmap_obstack_alloc_statP14bitmap_obstack
-.L195:
+.L234:
 	.long	_Z14bitmap_set_bitP15bitmap_head_defi
-.L194:
+.L232:
 	.long	_Z21flow_bb_inside_loop_pPK4loopPK15basic_block_def
-.L196:
+.L233:
 	.long	_ZL7ei_cond13edge_iteratorPP8edge_def
-.L199:
+.L237:
 	.long	_Z19bitmap_obstack_freeP15bitmap_head_def
 	.cfi_endproc
 .LFE929:
@@ -1474,35 +1430,28 @@
 _Z19dump_recorded_exitsP7__sFILE:
 .LFB937:
 	.cfi_startproc
-	mov.l	.L203,r1
+	mov.l	.L241,r1
 	mov	r4,r6
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
 	mov.l	@r1,r1
 	mov.l	@(16,r1),r1
 	mov.l	@(8,r1),r4
 	tst	r4,r4
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L201
-	mov	r15,r14
-	mov.l	.L204,r5
-	mov.l	.L205,r1
-	mov	r14,r15
+	bt	.L239
+	mov.l	.L242,r1
+	mov.l	.L243,r5
 	jmp	@r1
-	mov.l	@r15+,r14
-.L201:
-	mov	r14,r15
+	nop
+.L239:
 	rts	
-	mov.l	@r15+,r14
-.L206:
+	nop
+.L244:
 	.align 2
-.L203:
+.L241:
 	.long	cfun
-.L204:
-	.long	_ZL18dump_recorded_exitPPvS_
-.L205:
+.L242:
 	.long	htab_traverse
+.L243:
+	.long	_ZL18dump_recorded_exitPPvS_
 	.cfi_endproc
 .LFE937:
 	.size	_Z19dump_recorded_exitsP7__sFILE, .-_Z19dump_recorded_exitsP7__sFILE
@@ -1514,32 +1463,27 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	#8,r4
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 8
-	mov.l	.L209,r0
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 12
-	.cfi_offset 17, -12
-	.cfi_offset 14, -8
 	.cfi_offset 8, -4
-	.cfi_def_cfa_register 14
+	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 8
+	.cfi_offset 17, -8
+	mov.l	.L247,r0
 	jsr	@r0
-	mov	r15,r14
+	mov	#8,r4
 	tst	r0,r0
-	bf	.L208
-	mov.l	.L210,r1
-	mov.l	.L211,r4
-	mov.w	.L212,r5
-	mov.l	.L213,r6
+	bf	.L246
+	mov.l	.L248,r1
+	mov.l	.L249,r4
+	mov.w	.L250,r5
+	mov.l	.L251,r6
 	jsr	@r1
 	nop
-.L208:
-	mov.l	.L214,r8
+.L246:
+	mov.l	.L252,r8
 	mov.l	@r8,r1
 	mov.l	@(16,r1),r1
 	mov.l	@(8,r1),r4
-	mov.l	.L215,r1
+	mov.l	.L253,r1
 	jsr	@r1
 	nop
 	mov.l	@r8,r1
@@ -1550,27 +1494,29 @@
 	mov.l	@r1,r2
 	and	r3,r2
 	mov.l	r2,@r1
-	mov	r14,r15
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L212:
+.L250:
 	.short	1127
-.L216:
+.L254:
 	.align 2
-.L209:
+.L247:
 	.long	_ZL23loops_state_satisfies_pj
-.L210:
+.L248:
 	.long	_Z11fancy_abortPKciS0_
-.L211:
+.L249:
 	.long	.LC1
-.L213:
+.L251:
 	.long	_ZZ22release_recorded_exitsvE12__FUNCTION__
-.L214:
+.L252:
 	.long	cfun
-.L215:
+.L253:
 	.long	htab_delete
 	.cfi_endproc
 .LFE938:
@@ -1583,81 +1529,77 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 8
-	mov.l	.L223,r1
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 12
-	mov.l	@r1,r1
+	.cfi_def_cfa_offset 8
+	.cfi_offset 17, -8
+	mov.l	.L264,r1
 	mov.l	@(12,r4),r2
+	mov.l	@r1,r1
 	mov.l	@(4,r1),r1
 	mov.l	@(4,r1),r1
 	cmp/eq	r1,r2
-	.cfi_offset 17, -12
-	.cfi_offset 14, -8
-	.cfi_def_cfa_register 14
-	bf.s	.L218
-	mov	r15,r14
-	mov.l	.L224,r1
-	mov.l	.L225,r4
-	mov.w	.L226,r5
-	mov.l	.L227,r6
+	bf.s	.L256
+	mov	r4,r8
+	mov.l	.L265,r1
+	mov.l	.L266,r4
+	mov.w	.L267,r5
+	mov.l	.L268,r6
 	jsr	@r1
 	nop
-.L218:
-	mov.l	.L228,r0
+.L256:
+	mov.l	.L269,r0
 	jsr	@r0
 	nop
-	mov.l	@(28,r8),r3
+	mov.l	@(28,r8),r1
 	mov	r0,r4
 	mov	r0,r2
-	mov	r3,r1
-	tst	r3,r3
+	shll2	r1
+	add	r0,r1
 	mov	#0,r8
 	mov	#1,r7
-	bf.s	.L219
-	add	#1,r1
-	bra	.L219
-	mov	#1,r1
-.L221:
-	mov.l	@r2+,r3
+.L257:
+	cmp/eq	r1,r2
+	bt	.L263
+	mov.l	@r2,r3
 	mov.l	@(4,r3),r3
 	tst	r3,r3
-	bt	.L219
+	bt	.L258
 	mov.l	@(4,r3),r3
 	cmp/hi	r7,r3
-	bf	.L219
+	bf	.L258
 	add	#1,r8
-.L219:
-	dt	r1
-	bf	.L221
-	mov.l	.L229,r1
+.L258:
+	bra	.L257
+	add	#4,r2
+.L263:
+	mov.l	.L270,r1
 	jsr	@r1
 	nop
 	mov	r8,r0
-	mov	r14,r15
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L226:
+.L267:
 	.short	1177
-.L230:
+.L271:
 	.align 2
-.L223:
+.L264:
 	.long	cfun
-.L224:
+.L265:
 	.long	_Z11fancy_abortPKciS0_
-.L225:
+.L266:
 	.long	.LC1
-.L227:
+.L268:
 	.long	_ZZ17num_loop_branchesPK4loopE12__FUNCTION__
-.L228:
+.L269:
 	.long	_Z13get_loop_bodyPK4loop
-.L229:
+.L270:
 	.long	free
 	.cfi_endproc
 .LFE940:
@@ -1670,89 +1612,89 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	tst	r4,r4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov	r4,r8
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
-	mov	r5,r9
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 16
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 20
-	.cfi_offset 17, -20
-	.cfi_offset 14, -16
 	.cfi_offset 10, -12
-	.cfi_def_cfa_register 14
-	bt.s	.L232
-	mov	r15,r14
+	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 16
+	.cfi_offset 17, -16
+	tst	r4,r4
+	mov	r4,r8
+	bt.s	.L279
+	mov	r5,r9
 	tst	r5,r5
-	bt	.L238
-	mov.l	@(32,r4),r3
-	tst	r3,r3
-	bt	.L239
-	mov.l	@(4,r3),r2
-	bra	.L245
+	bt	.L280
+	mov.l	@(32,r4),r2
+	tst	r2,r2
+	bt	.L281
+	mov.l	@(4,r2),r1
+	bra	.L288
 	mov.l	@(32,r9),r7
-.L239:
-	mov	#0,r2
+.L281:
+	mov	#0,r1
 	mov.l	@(32,r9),r7
-.L245:
+.L288:
 	tst	r7,r7
-	bt	.L240
-	mov.l	@(4,r7),r1
-	cmp/hs	r1,r2
-	bt	.L234
-	add	#2,r2
-	shll2	r2
-	mov	r2,r0
-	bra	.L235
-	mov.l	@(r0,r7),r9
-.L240:
-	mov	#0,r1
-.L234:
-	cmp/hi	r1,r2
-	bf.s	.L235
-	add	#2,r1
+	bt	.L282
+	mov.l	@(4,r7),r3
+	cmp/hs	r3,r1
+	bt	.L275
 	shll2	r1
-	mov	r1,r0
-	bra	.L235
-	mov.l	@(r0,r3),r8
-.L237:
+	add	r1,r7
+	mov.l	@(8,r7),r9
+.L277:
+	mov.l	.L284,r10
+	bra	.L286
+	cmp/eq	r9,r8
+.L282:
+	mov	#0,r3
+.L275:
+	cmp/hi	r3,r1
+	bf	.L277
+	shll2	r3
+	add	r3,r2
+	bra	.L277
+	mov.l	@(8,r2),r8
+.L276:
+	cmp/eq	r9,r8
+.L286:
+	bt.s	.L287
+	mov	r8,r0
 	jsr	@r10
 	mov.l	@(32,r8),r4
 	mov.l	@(32,r9),r4
 	jsr	@r10
 	mov	r0,r8
-	bra	.L241
+	bra	.L276
 	mov	r0,r9
-.L235:
-	mov.l	.L242,r10
-.L241:
-	cmp/eq	r9,r8
-	bf.s	.L237
-	mov	r9,r0
-	bra	.L244
-	nop
-.L238:
-	mov	r4,r9
-.L232:
-	mov	r9,r0
-.L244:
-	mov	r14,r15
+.L279:
+	bra	.L273
+	mov	r5,r0
+.L280:
+	mov	r8,r0
+.L273:
+.L287:
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L243:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L285:
 	.align 2
-.L242:
-	.long	_ZL10loop_outerPK4loop.clone.13
+.L284:
+	.long	_ZL10loop_outerPK4loop.isra.13
 	.cfi_endproc
 .LFE943:
 	.size	_Z16find_common_loopP4loopS0_, .-_Z16find_common_loopP4loopS0_
@@ -1764,184 +1706,216 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	extu.b	r6,r8
 	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	extu.b	r5,r9
 	.cfi_offset 9, -8
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
+	.cfi_offset 10, -12
 	mov.l	r11,@-r15
 	.cfi_def_cfa_offset 16
-	mov	r4,r11
 	.cfi_offset 11, -16
-	.cfi_offset 10, -12
 	mov.l	r12,@-r15
 	.cfi_def_cfa_offset 20
-	mov	#8,r4
+	.cfi_offset 12, -20
 	mov.l	r13,@-r15
 	.cfi_def_cfa_offset 24
+	.cfi_offset 13, -24
 	mov.l	r14,@-r15
 	.cfi_def_cfa_offset 28
-	mov.l	.L254,r0
+	.cfi_offset 14, -28
 	sts.l	pr,@-r15
 	.cfi_def_cfa_offset 32
-	add	#-8,r15
-	.cfi_def_cfa_offset 40
 	.cfi_offset 17, -32
-	.cfi_offset 14, -28
-	.cfi_offset 13, -24
-	.cfi_offset 12, -20
-	.cfi_def_cfa_register 14
+	add	#-4,r15
+	.cfi_def_cfa_offset 36
+	mov.l	.L315,r0
+	mov	r4,r11
+	extu.b	r5,r12
+	extu.b	r6,r8
 	jsr	@r0
-	mov	r15,r14
+	mov	#8,r4
 	tst	r0,r0
-	bt.s	.L246
+	bt.s	.L289
 	tst	r8,r8
-	bf.s	.L265
-	tst	r9,r9
+	bf.s	.L326
+	tst	r12,r12
 	mov.l	@r11,r1
-	mov.l	@(12,r1),r10
-	tst	r10,r10
-	bt	.L248
+	mov.l	@(12,r1),r9
+	tst	r9,r9
+	bt	.L292
 	mov.l	@(4,r11),r5
 	mov.l	@(12,r5),r8
 	tst	r8,r8
-	bt.s	.L265
-	tst	r9,r9
-	mov.l	.L255,r0
+	bt.s	.L326
+	tst	r12,r12
+	mov.l	.L316,r0
 	jsr	@r0
-	mov	r10,r4
+	mov	r9,r4
 	tst	r0,r0
-	bf.s	.L265
-	tst	r9,r9
-	mov.l	.L256,r0
-	mov	r8,r5
-	jsr	@r0
-	mov	r10,r4
-	mov	r0,r2
-	mov.l	.L257,r1
-	mov.l	.L258,r13
-	bra	.L249
-	mov	#0,r8
-.L250:
-	mov.l	r1,@r14
-	jsr	@r1
-	mov.l	r2,@(4,r14)
-	mov	r10,r3
-	add	#64,r3
-	mov.l	@(32,r3),r7
-	mov	r0,r12
-	mov.l	r8,@(12,r0)
-	mov	r12,r8
-	mov.l	@(8,r7),r3
-	mov.l	r7,@(4,r0)
-	mov.l	r0,@(4,r3)
-	mov.l	r3,@(8,r0)
-	mov.l	@(4,r0),r3
-	mov.l	@(32,r10),r4
-	mov.l	r11,@r0
-	jsr	@r13
-	mov.l	r0,@(8,r3)
-	mov.l	@(4,r14),r2
-	mov	r0,r10
-	mov.l	@r14,r1
-.L249:
-	cmp/eq	r2,r10
-	bf.s	.L250
-	mov	#16,r4
-	tst	r8,r8
-	bf	.L251
-.L248:
-	tst	r9,r9
-.L265:
-	bf	.L246
-	mov	#0,r8
-.L251:
-	mov.l	.L259,r9
+	bf.s	.L326
+	tst	r12,r12
+	bra	.L313
+	mov	r9,r4
+.L314:
+	tst	r10,r10
+	bf	.L295
+.L292:
+	tst	r12,r12
+.L326:
+	bf	.L289
+	mov	#0,r10
+.L295:
+	mov.l	.L317,r9
 	mov	r11,r4
 	mov.l	@r9,r1
 	mov.l	@(16,r1),r1
-	mov.l	@(8,r1),r12
-	mov.l	.L260,r1
+	mov.l	@(8,r1),r8
+	mov.l	.L318,r1
 	mov.l	@r1,r0
 	jsr	@r0
-	mov	#-1,r10
+	mov	#1,r12
+	tst	r10,r10
 	mov	r0,r6
-	tst	r8,r8
-	mov.l	.L261,r0
-	negc	r10,r10
-	extu.b	r10,r10
+	movt	r0
+	xor	r0,r12
+	mov.l	.L319,r0
+	mov	r8,r4
 	mov	r11,r5
-	mov	r12,r4
 	jsr	@r0
-	mov	r10,r7
+	mov	r12,r7
 	tst	r0,r0
-	bt.s	.L246
-	mov	r0,r11
-	tst	r10,r10
-	bt	.L252
+	bt.s	.L289
+	mov	r0,r8
+	tst	r12,r12
+	bt	.L297
 	mov.l	@r0,r4
 	tst	r4,r4
-	bt	.L253
-	mov.l	.L262,r1
+	bt	.L298
+	mov.l	.L320,r1
 	jsr	@r1
 	nop
-.L253:
-	bra	.L246
-	mov.l	r8,@r11
-.L252:
+.L298:
+	bra	.L289
+	mov.l	r10,@r8
+.L297:
 	mov.l	@r9,r1
 	mov	r0,r5
 	mov.l	@(16,r1),r1
 	mov.l	@(8,r1),r4
-	mov.l	.L263,r1
-	add	#8,r14
-	mov	r14,r15
+	mov.l	.L321,r1
+	add	#4,r15
+	.cfi_remember_state
+	.cfi_def_cfa_offset 32
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 28
 	mov.l	@r15+,r14
+	.cfi_restore 14
+	.cfi_def_cfa_offset 24
 	mov.l	@r15+,r13
+	.cfi_restore 13
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
+	.cfi_restore 8
 	jmp	@r1
 	mov.l	@r15+,r8
-.L246:
-	add	#8,r14
-	mov	r14,r15
+	.cfi_def_cfa_offset 0
+.L313:
+	.cfi_restore_state
+	mov.l	.L322,r0
+	mov.l	.L323,r14
+	mov.l	.L324,r13
+	jsr	@r0
+	mov	r8,r5
+	mov	r0,r3
+	mov	#0,r10
+.L299:
+	cmp/eq	r3,r9
+	bt	.L314
+	mov.l	r3,@r15
+	jsr	@r14
+	mov	#16,r4
+	mov	r9,r1
+	add	#64,r1
+	mov.l	@(32,r1),r2
+	mov	r0,r8
+	mov.l	r11,@r0
+	mov.l	@(8,r2),r1
+	mov.l	r2,@(4,r0)
+	mov.l	r1,@(8,r0)
+	mov.l	r0,@(4,r1)
+	mov.l	@(4,r0),r1
+	mov.l	@(32,r9),r4
+	mov.l	r0,@(8,r1)
+	jsr	@r13
+	mov.l	r10,@(12,r0)
+	mov	r0,r9
+	mov	r8,r10
+	bra	.L299
+	mov.l	@r15,r3
+.L289:
+	add	#4,r15
+	.cfi_def_cfa_offset 32
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 28
 	mov.l	@r15+,r14
+	.cfi_restore 14
+	.cfi_def_cfa_offset 24
 	mov.l	@r15+,r13
+	.cfi_restore 13
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L264:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L325:
 	.align 2
-.L254:
+.L315:
 	.long	_ZL23loops_state_satisfies_pj
-.L255:
+.L316:
 	.long	_Z21flow_bb_inside_loop_pPK4loopPK15basic_block_def
-.L256:
-	.long	_Z16find_common_loopP4loopS0_
-.L257:
-	.long	_Z23ggc_internal_alloc_statj
-.L258:
-	.long	_ZL10loop_outerPK4loop.clone.13
-.L259:
+.L317:
 	.long	cfun
-.L260:
+.L318:
 	.long	htab_hash_pointer
-.L261:
+.L319:
 	.long	htab_find_slot_with_hash
-.L262:
+.L320:
 	.long	_ZL14loop_exit_freePv
-.L263:
+.L321:
 	.long	htab_clear_slot
+.L322:
+	.long	_Z16find_common_loopP4loopS0_
+.L323:
+	.long	_Z23ggc_internal_alloc_statj
+.L324:
+	.long	_ZL10loop_outerPK4loop.isra.13
 	.cfi_endproc
 .LFE934:
 	.size	_Z16rescan_loop_exitP8edge_defbb, .-_Z16rescan_loop_exitP8edge_defbb
@@ -1953,431 +1927,448 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
+	.cfi_offset 9, -8
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
+	.cfi_offset 10, -12
 	mov.l	r11,@-r15
 	.cfi_def_cfa_offset 16
+	.cfi_offset 11, -16
 	mov.l	r12,@-r15
 	.cfi_def_cfa_offset 20
-	mov.l	.L273,r12
 	.cfi_offset 12, -20
-	.cfi_offset 11, -16
-	.cfi_offset 10, -12
-	.cfi_offset 9, -8
-	.cfi_offset 8, -4
 	mov.l	r13,@-r15
 	.cfi_def_cfa_offset 24
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 28
-	mov.l	@r12,r1
+	.cfi_offset 13, -24
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 32
+	.cfi_def_cfa_offset 28
+	.cfi_offset 17, -28
+	add	#-16,r15
+	.cfi_def_cfa_offset 44
+	mov.l	.L339,r10
+	mov.l	@r10,r1
 	mov.l	@(16,r1),r8
-	add	#-4,r15
-	.cfi_def_cfa_offset 36
 	tst	r8,r8
-	.cfi_offset 17, -32
-	.cfi_offset 14, -28
-	.cfi_offset 13, -24
-	.cfi_def_cfa_register 14
-	bt.s	.L266
-	mov	r15,r14
-	mov.l	.L274,r0
+	bt	.L327
+	mov.l	.L340,r0
 	jsr	@r0
 	mov	#8,r4
 	tst	r0,r0
-	bf	.L266
+	bf	.L327
 	mov.l	@r8,r0
 	mov.l	@(8,r8),r1
 	or	#8,r0
 	tst	r1,r1
-	bt.s	.L268
+	bt.s	.L329
 	mov.l	r0,@r8
-	mov.l	.L275,r1
-	mov.l	.L276,r4
-	mov.w	.L277,r5
-	mov.l	.L278,r6
+	mov.l	.L341,r1
+	mov.l	.L342,r4
+	mov.w	.L343,r5
+	mov.l	.L344,r6
 	jsr	@r1
 	nop
-.L268:
-	mov.l	.L279,r0
-	mov.l	.L280,r10
+.L329:
+	mov.l	.L345,r0
+	mov.l	.L346,r11
 	jsr	@r0
 	nop
-	mov.l	.L281,r1
-	add	#-12,r15
+	mov.l	.L347,r1
 	mov	r0,r4
-	mov.l	r1,@r15
+	mov.l	.L348,r0
 	add	r4,r4
-	mov.l	.L282,r1
-	mov.l	.L283,r0
+	mov.l	r1,@r15
+	mov.l	.L349,r1
+	mov.l	.L350,r5
 	mov.l	r1,@(4,r15)
-	mov.l	.L284,r1
-	mov.l	.L285,r5
-	mov.l	.L286,r6
-	mov.l	.L287,r7
-	.cfi_escape 0x2e,0xc
+	mov.l	.L351,r1
+	mov.l	.L352,r6
+	mov.l	.L353,r7
 	jsr	@r0
 	mov.l	r1,@(8,r15)
-	mov.l	@r12,r1
-	add	#12,r15
+	mov.l	@r10,r1
 	mov.l	r0,@(8,r8)
 	mov.l	@(4,r1),r1
+	mov.l	.L354,r12
 	mov.l	@r1,r1
-	bra	.L269
 	mov.l	@(28,r1),r8
-.L272:
+.L330:
+	mov.l	@r10,r1
+	mov.l	@(4,r1),r1
+	mov.l	@(4,r1),r1
+	cmp/eq	r1,r8
+	bt	.L327
 	mov	r8,r13
 	add	#4,r13
-	bra	.L270
 	mov	#0,r9
-.L271:
-	mov.l	.L288,r1
-	mov	#1,r5
-	mov.l	@r14,r4
-	.cfi_escape 0x2e,0x0
-	jsr	@r1
-	mov	#0,r6
-.L270:
+	mov	r15,r6
+.L356:
 	mov	r9,r4
 	mov	r13,r5
-	jsr	@r10
-	mov	r14,r6
+	jsr	@r11
+	add	#12,r6
 	tst	r0,r0
-	bf.s	.L271
+	bt.s	.L338
 	add	#1,r9
+	mov.l	@(12,r15),r4
+	mov	#1,r5
+	jsr	@r12
+	mov	#0,r6
+	bra	.L356
+	mov	r15,r6
+.L338:
+	bra	.L330
 	mov.l	@(28,r8),r8
-.L269:
-	mov.l	@r12,r1
-	mov.l	@(4,r1),r1
-	mov.l	@(4,r1),r1
-	cmp/eq	r1,r8
-	bf	.L272
-.L266:
-	add	#4,r14
-	mov	r14,r15
+.L327:
+	add	#16,r15
+	.cfi_def_cfa_offset 28
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 24
 	mov.l	@r15+,r13
+	.cfi_restore 13
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L277:
+.L343:
 	.short	1078
-.L289:
+.L355:
 	.align 2
-.L273:
+.L339:
 	.long	cfun
-.L274:
+.L340:
 	.long	_ZL23loops_state_satisfies_pj
-.L275:
+.L341:
 	.long	_Z11fancy_abortPKciS0_
-.L276:
+.L342:
 	.long	.LC1
-.L278:
+.L344:
 	.long	_ZZ17record_loop_exitsvE12__FUNCTION__
-.L279:
+.L345:
 	.long	_ZL15number_of_loopsv
-.L280:
+.L346:
 	.long	_ZL7ei_cond13edge_iteratorPP8edge_def
-.L281:
+.L347:
 	.long	_Z34ggc_cleared_alloc_htab_ignore_argsjj
-.L282:
-	.long	_Z36ggc_cleared_alloc_ptr_array_two_argsjj
-.L283:
+.L348:
 	.long	htab_create_typed_alloc
-.L284:
-	.long	_Z8ggc_freePv
-.L285:
+.L349:
+	.long	_Z36ggc_cleared_alloc_ptr_array_two_argsjj
+.L350:
 	.long	_ZL14loop_exit_hashPKv
-.L286:
+.L351:
+	.long	_Z8ggc_freePv
+.L352:
 	.long	_ZL12loop_exit_eqPKvS0_
-.L287:
+.L353:
 	.long	_ZL14loop_exit_freePv
-.L288:
+.L354:
 	.long	_Z16rescan_loop_exitP8edge_defbb
 	.cfi_endproc
 .LFE935:
 	.size	_Z17record_loop_exitsv, .-_Z17record_loop_exitsv
 	.align 1
-	.global	_Z20remove_bb_from_loopsP15basic_block_def
-	.type	_Z20remove_bb_from_loopsP15basic_block_def, @function
-_Z20remove_bb_from_loopsP15basic_block_def:
-.LFB942:
+	.global	_Z14add_bb_to_loopP15basic_block_defP4loop
+	.type	_Z14add_bb_to_loopP15basic_block_defP4loop, @function
+_Z14add_bb_to_loopP15basic_block_defP4loop:
+.LFB941:
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
+	.cfi_offset 9, -8
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
+	.cfi_offset 10, -12
 	mov.l	r11,@-r15
 	.cfi_def_cfa_offset 16
+	.cfi_offset 11, -16
 	mov.l	r12,@-r15
 	.cfi_def_cfa_offset 20
+	.cfi_offset 12, -20
 	mov.l	r13,@-r15
 	.cfi_def_cfa_offset 24
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 28
+	.cfi_offset 13, -24
 	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 28
+	.cfi_offset 17, -28
+	add	#-4,r15
 	.cfi_def_cfa_offset 32
 	mov.l	@(12,r4),r1
-	add	#-4,r15
-	.cfi_def_cfa_offset 36
 	tst	r1,r1
-	.cfi_offset 17, -32
-	.cfi_offset 14, -28
-	.cfi_offset 13, -24
-	.cfi_offset 12, -20
-	.cfi_offset 11, -16
-	.cfi_offset 10, -12
-	.cfi_offset 9, -8
-	.cfi_def_cfa_register 14
-	bf.s	.L291
-	mov	r15,r14
-	mov.l	.L298,r1
-	mov.l	.L299,r4
-	mov.w	.L300,r5
-	mov.l	.L301,r6
+	bt.s	.L358
+	mov	r4,r8
+	mov.l	.L372,r1
+	mov.l	.L373,r4
+	mov.w	.L374,r5
+	mov.l	.L375,r6
 	jsr	@r1
 	nop
-.L291:
-	mov.l	@(28,r1),r2
-	add	#-1,r2
-	mov.l	r2,@(28,r1)
-	mov.l	@(32,r1),r2
-	mov	r2,r7
-	tst	r2,r2
-	bt.s	.L292
-	add	#8,r7
-	mov	#0,r1
-.L293:
-	mov.l	@(4,r2),r3
-	cmp/hs	r3,r1
-	bt	.L292
-	mov.l	@r7+,r6
+.L358:
+	mov.l	@(28,r5),r1
+	mov.l	@(32,r5),r3
 	add	#1,r1
-	mov.l	@(28,r6),r3
-	add	#-1,r3
-	bra	.L293
-	mov.l	r3,@(28,r6)
-.L292:
+	mov.l	r5,@(12,r4)
+	tst	r3,r3
+	bt.s	.L359
+	mov.l	r1,@(28,r5)
 	mov	#0,r1
-	mov	r8,r13
-	mov	r14,r10
-	mov.l	r1,@(12,r8)
-	add	#4,r13
-	mov	#0,r9
-	mov.l	.L304,r11
-	bra	.L294
-	add	#-60,r10
-.L295:
-	mov.l	.L305,r1
-	mov	#0,r5
-	mov.l	@(60,r10),r4
-	jsr	@r1
-	mov	#1,r6
-.L294:
-	mov	r9,r4
-	mov	r13,r5
+.L365:
+	mov.l	@(4,r3),r2
+	cmp/hs	r2,r1
+	bt.s	.L359
+	mov	r1,r2
+	shll2	r2
+	add	r3,r2
+	mov.l	@(8,r2),r7
+	add	#1,r1
+	mov.l	@(28,r7),r2
+	add	#1,r2
+	bra	.L365
+	mov.l	r2,@(28,r7)
+.L359:
+	mov.l	.L378,r11
+	mov	r8,r12
+	mov.l	.L379,r10
+	add	#4,r12
+	mov	#0,r9
+	mov	r9,r4
+.L381:
+	mov	r12,r5
 	jsr	@r11
-	mov	r14,r6
+	mov	r15,r6
 	tst	r0,r0
-	bf.s	.L295
+	mov.l	.L378,r13
+	bt.s	.L370
 	add	#1,r9
-	mov	r14,r11
-	mov	#0,r9
-	mov.l	.L304,r12
-	mov.l	.L305,r10
-	bra	.L296
-	add	#-60,r11
-.L297:
-	mov.l	@(60,r11),r4
-	mov	#0,r5
+	mov.l	@(0,r15),r4
+	mov	#1,r5
 	jsr	@r10
-	mov	#1,r6
-.L296:
+	mov	#0,r6
+	bra	.L381
 	mov	r9,r4
+.L370:
+	mov.l	.L379,r10
+	mov	#0,r9
+	mov	r9,r4
+.L382:
 	mov	r8,r5
-	jsr	@r12
-	mov	r14,r6
+	jsr	@r13
+	mov	r15,r6
 	tst	r0,r0
-	bf.s	.L297
+	bt.s	.L371
 	add	#1,r9
-	add	#4,r14
-	mov	r14,r15
+	mov.l	@(0,r15),r4
+	mov	#1,r5
+	jsr	@r10
+	mov	#0,r6
+	bra	.L382
+	mov	r9,r4
+.L371:
+	add	#4,r15
+	.cfi_def_cfa_offset 28
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 24
 	mov.l	@r15+,r13
+	.cfi_restore 13
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L300:
-	.short	1224
-.L306:
+.L374:
+	.short	1198
+.L380:
 	.align 2
-.L298:
+.L372:
 	.long	_Z11fancy_abortPKciS0_
-.L299:
+.L373:
 	.long	.LC1
-.L301:
-	.long	_ZZ20remove_bb_from_loopsP15basic_block_defE12__FUNCTION__
-.L304:
+.L375:
+	.long	_ZZ14add_bb_to_loopP15basic_block_defP4loopE12__FUNCTION__
+.L378:
 	.long	_ZL7ei_cond13edge_iteratorPP8edge_def
-.L305:
+.L379:
 	.long	_Z16rescan_loop_exitP8edge_defbb
 	.cfi_endproc
-.LFE942:
-	.size	_Z20remove_bb_from_loopsP15basic_block_def, .-_Z20remove_bb_from_loopsP15basic_block_def
+.LFE941:
+	.size	_Z14add_bb_to_loopP15basic_block_defP4loop, .-_Z14add_bb_to_loopP15basic_block_defP4loop
 	.align 1
-	.global	_Z14add_bb_to_loopP15basic_block_defP4loop
-	.type	_Z14add_bb_to_loopP15basic_block_defP4loop, @function
-_Z14add_bb_to_loopP15basic_block_defP4loop:
-.LFB941:
+	.global	_Z20remove_bb_from_loopsP15basic_block_def
+	.type	_Z20remove_bb_from_loopsP15basic_block_def, @function
+_Z20remove_bb_from_loopsP15basic_block_def:
+.LFB942:
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
+	.cfi_offset 9, -8
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
+	.cfi_offset 10, -12
 	mov.l	r11,@-r15
 	.cfi_def_cfa_offset 16
+	.cfi_offset 11, -16
 	mov.l	r12,@-r15
 	.cfi_def_cfa_offset 20
+	.cfi_offset 12, -20
 	mov.l	r13,@-r15
 	.cfi_def_cfa_offset 24
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 28
+	.cfi_offset 13, -24
 	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 28
+	.cfi_offset 17, -28
+	add	#-4,r15
 	.cfi_def_cfa_offset 32
 	mov.l	@(12,r4),r1
-	add	#-4,r15
-	.cfi_def_cfa_offset 36
 	tst	r1,r1
-	.cfi_offset 17, -32
-	.cfi_offset 14, -28
-	.cfi_offset 13, -24
-	.cfi_offset 12, -20
-	.cfi_offset 11, -16
-	.cfi_offset 10, -12
-	.cfi_offset 9, -8
-	.cfi_def_cfa_register 14
-	bt.s	.L308
-	mov	r15,r14
-	mov.l	.L315,r1
-	mov.l	.L316,r4
-	mov.w	.L317,r5
-	mov.l	.L318,r6
+	bf.s	.L384
+	mov	r4,r8
+	mov.l	.L398,r1
+	mov.l	.L399,r4
+	mov.w	.L400,r5
+	mov.l	.L401,r6
 	jsr	@r1
 	nop
-.L308:
-	mov.l	@(28,r5),r1
-	mov.l	@(32,r5),r2
-	add	#1,r1
-	mov.l	r5,@(12,r4)
-	mov	r2,r7
-	mov.l	r1,@(28,r5)
-	tst	r2,r2
-	bt.s	.L309
-	add	#8,r7
+.L384:
+	mov.l	@(28,r1),r2
+	mov.l	@(32,r1),r3
+	add	#-1,r2
+	tst	r3,r3
+	bt.s	.L385
+	mov.l	r2,@(28,r1)
 	mov	#0,r1
-.L310:
-	mov.l	@(4,r2),r3
-	cmp/hs	r3,r1
-	bt.s	.L324
-	mov	r8,r13
-	mov.l	@r7+,r6
+.L391:
+	mov.l	@(4,r3),r2
+	cmp/hs	r2,r1
+	bt.s	.L385
+	mov	r1,r2
+	shll2	r2
+	add	r3,r2
+	mov.l	@(8,r2),r7
 	add	#1,r1
-	mov.l	@(28,r6),r3
-	add	#1,r3
-	bra	.L310
-	mov.l	r3,@(28,r6)
-.L309:
-	mov	r8,r13
-.L324:
-	mov	r14,r10
-	add	#4,r13
+	mov.l	@(28,r7),r2
+	add	#-1,r2
+	bra	.L391
+	mov.l	r2,@(28,r7)
+.L385:
+	mov	#0,r1
+	mov.l	.L404,r11
+	mov	r8,r12
+	mov.l	.L405,r10
+	add	#4,r12
+	mov.l	r1,@(12,r8)
 	mov	#0,r9
-	mov.l	.L321,r11
-	bra	.L311
-	add	#-60,r10
-.L312:
-	mov.l	.L322,r1
-	mov	#1,r5
-	mov.l	@(60,r10),r4
-	jsr	@r1
-	mov	#0,r6
-.L311:
 	mov	r9,r4
-	mov	r13,r5
+.L407:
+	mov	r12,r5
 	jsr	@r11
-	mov	r14,r6
+	mov	r15,r6
 	tst	r0,r0
-	bf.s	.L312
+	mov.l	.L404,r13
+	bt.s	.L396
 	add	#1,r9
-	mov	r14,r11
-	mov	#0,r9
-	mov.l	.L321,r12
-	mov.l	.L322,r10
-	bra	.L313
-	add	#-60,r11
-.L314:
-	mov.l	@(60,r11),r4
-	mov	#1,r5
+	mov.l	@(0,r15),r4
+	mov	#0,r5
 	jsr	@r10
-	mov	#0,r6
-.L313:
+	mov	#1,r6
+	bra	.L407
 	mov	r9,r4
+.L396:
+	mov.l	.L405,r10
+	mov	#0,r9
+	mov	r9,r4
+.L408:
 	mov	r8,r5
-	jsr	@r12
-	mov	r14,r6
+	jsr	@r13
+	mov	r15,r6
 	tst	r0,r0
-	bf.s	.L314
+	bt.s	.L397
 	add	#1,r9
-	add	#4,r14
-	mov	r14,r15
+	mov.l	@(0,r15),r4
+	mov	#0,r5
+	jsr	@r10
+	mov	#1,r6
+	bra	.L408
+	mov	r9,r4
+.L397:
+	add	#4,r15
+	.cfi_def_cfa_offset 28
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 24
 	mov.l	@r15+,r13
+	.cfi_restore 13
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L317:
-	.short	1198
-.L323:
+.L400:
+	.short	1224
+.L406:
 	.align 2
-.L315:
+.L398:
 	.long	_Z11fancy_abortPKciS0_
-.L316:
+.L399:
 	.long	.LC1
-.L318:
-	.long	_ZZ14add_bb_to_loopP15basic_block_defP4loopE12__FUNCTION__
-.L321:
+.L401:
+	.long	_ZZ20remove_bb_from_loopsP15basic_block_defE12__FUNCTION__
+.L404:
 	.long	_ZL7ei_cond13edge_iteratorPP8edge_def
-.L322:
+.L405:
 	.long	_Z16rescan_loop_exitP8edge_defbb
 	.cfi_endproc
-.LFE941:
-	.size	_Z14add_bb_to_loopP15basic_block_defP4loop, .-_Z14add_bb_to_loopP15basic_block_defP4loop
+.LFE942:
+	.size	_Z20remove_bb_from_loopsP15basic_block_def, .-_Z20remove_bb_from_loopsP15basic_block_def
 	.align 1
 	.global	_Z11delete_loopP4loop
 	.type	_Z11delete_loopP4loop, @function
@@ -2386,19 +2377,14 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 8
-	mov.l	.L326,r1
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 12
-	.cfi_offset 17, -12
-	.cfi_offset 14, -8
-	.cfi_def_cfa_register 14
+	.cfi_def_cfa_offset 8
+	.cfi_offset 17, -8
+	mov.l	.L410,r1
 	jsr	@r1
-	mov	r15,r14
-	mov.l	.L327,r1
+	mov	r4,r8
+	mov.l	.L411,r1
 	mov	r8,r4
 	mov.l	@r1,r1
 	mov.l	@(16,r1),r1
@@ -2409,19 +2395,21 @@
 	add	r1,r2
 	mov	#0,r1
 	mov.l	r1,@r2
-	mov.l	.L328,r1
-	mov	r14,r15
+	mov.l	.L412,r1
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 4
+	.cfi_restore 8
 	jmp	@r1
 	mov.l	@r15+,r8
-.L329:
+	.cfi_def_cfa_offset 0
+.L413:
 	.align 2
-.L326:
+.L410:
 	.long	_Z26flow_loop_tree_node_removeP4loop
-.L327:
+.L411:
 	.long	cfun
-.L328:
+.L412:
 	.long	_Z14flow_loop_freeP4loop
 	.cfi_endproc
 .LFE944:
@@ -2434,72 +2422,69 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 12
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 16
-	mov.l	.L336,r9
-	.cfi_offset 17, -16
-	.cfi_offset 14, -12
 	.cfi_offset 9, -8
-	.cfi_def_cfa_register 14
-	bra	.L331
-	mov	r15,r14
-.L332:
+	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 12
+	.cfi_offset 17, -12
+	mov.l	.L421,r9
+	mov	r4,r8
+	mov.l	@(36,r8),r4
+.L427:
+	tst	r4,r4
+	bt	.L419
 	jsr	@r9
 	nop
-.L331:
+	bra	.L427
 	mov.l	@(36,r8),r4
-	tst	r4,r4
-	bf	.L332
-	mov.l	.L337,r0
+.L419:
+	mov.l	.L422,r0
 	jsr	@r0
 	mov.l	@(32,r8),r4
 	mov	r0,r9
-	mov.l	.L338,r0
+	mov.l	.L423,r0
 	jsr	@r0
 	mov	r8,r4
-	mov.l	@(28,r8),r3
+	mov.l	@(28,r8),r1
 	mov	r0,r4
 	mov	r0,r2
-	mov	r3,r1
-	tst	r3,r3
-	bf.s	.L333
-	add	#1,r1
-	bra	.L333
-	mov	#1,r1
-.L334:
+	shll2	r1
+	add	r0,r1
+.L417:
+	cmp/eq	r1,r2
+	bt	.L420
 	mov.l	@r2+,r3
+	bra	.L417
 	mov.l	r9,@(12,r3)
-.L333:
-	dt	r1
-	bf	.L334
-	mov.l	.L339,r1
+.L420:
+	mov.l	.L424,r1
 	jsr	@r1
 	nop
-	mov.l	.L340,r1
+	mov.l	.L425,r1
 	mov	r8,r4
-	mov	r14,r15
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
+	.cfi_restore 8
 	jmp	@r1
 	mov.l	@r15+,r8
-.L341:
+	.cfi_def_cfa_offset 0
+.L426:
 	.align 2
-.L336:
+.L421:
 	.long	_Z16cancel_loop_treeP4loop
-.L337:
-	.long	_ZL10loop_outerPK4loop.clone.13
-.L338:
+.L422:
+	.long	_ZL10loop_outerPK4loop.isra.13
+.L423:
 	.long	_Z13get_loop_bodyPK4loop
-.L339:
+.L424:
 	.long	free
-.L340:
+.L425:
 	.long	_Z11delete_loopP4loop
 	.cfi_endproc
 .LFE946:
@@ -2510,21 +2495,14 @@
 _Z15loop_latch_edgePK4loop:
 .LFB948:
 	.cfi_startproc
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
+	mov.l	.L429,r0
 	mov	r4,r1
 	mov.l	@(8,r1),r5
-	mov	r15,r14
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	mov.l	@(12,r4),r4
-	mov.l	.L343,r0
-	mov	r14,r15
 	jmp	@r0
-	mov.l	@r15+,r14
-.L344:
+	mov.l	@(12,r4),r4
+.L430:
 	.align 2
-.L343:
+.L429:
 	.long	_Z9find_edgeP15basic_block_defS0_
 	.cfi_endproc
 .LFE948:
